#!/bin/bash

FONT=lat2-16.psf
SIZE=352x288
#SIZE=640x480


FILE=$1
FILE=${FILE%.ti}.ti

if [ $1 = "+" ] ; then 
	FILE=$2
	FILE=${FILE%.ti}.ti
        TXT2PNG_FLAGS=`grep '^TXT2PNG_FLAGS:' $FILE|sed s/^[^:]*://`
	RENDER="./txt2png -f $FONT -S $SIZE $TXT2PNG_FLAGS"
	shift
else
	RENDER=txt2txt
fi

if [ "$#" -lt 1 ] ; then
	echo "usage:$0 [+] in.ti [ beg-frame [ end-frame ] ] "
	exit 0
fi

txt2txt() {
	cat > ${2%.png}.txt
}

FRAME=$2
ENDFRAME=$3

if [ -z "$FRAME" ] ; then FRAME=0; fi

if [ -z "$ENDFRAME" ] ; then 
	ENDFRAME=`m4 -D__count_frames title.m4 $FILE`
fi

if [ -z  "$ENDFRAME" ] ; then
	echo "posibly missing \"_bye()\" in $FILE"
	exit 1
fi

FILEWO=${FILE%.ti}
DIR=$FILEWO

mkdir -p ${DIR}
echo ENDFRAME:$ENDFRAME FRAME: $FRAME FILE: $FILE

while [ "$FRAME" -le "$ENDFRAME" ] ; do
	FRAMEF=`printf "%04i" $FRAME`
	echo -n "frame $FRAMEF ... "
	m4 -D__frame=$FRAME title.m4 $FILE |
	sed 's/&;/,/g' |
	$RENDER - $DIR/${FILEWO}.$FRAMEF.png
	echo done
	FRAME=`expr $FRAME + 1`
done
